import { EditorState, Transaction } from "../../state/src";
export declare const closeHistorySlot: import("../../extension/src/extension").SlotType<boolean>;
interface CompleteHistoryConfig {
    minDepth: number;
    newGroupDelay: number;
}
export declare type HistoryConfig = Partial<CompleteHistoryConfig>;
export declare const history: (spec?: Partial<CompleteHistoryConfig>) => import("../../extension/src/extension").Extension;
export declare const undo: ({ state, dispatch }: {
    state: EditorState;
    dispatch: (tr: Transaction) => void;
}) => boolean;
export declare const redo: ({ state, dispatch }: {
    state: EditorState;
    dispatch: (tr: Transaction) => void;
}) => boolean;
export declare const undoSelection: ({ state, dispatch }: {
    state: EditorState;
    dispatch: (tr: Transaction) => void;
}) => boolean;
export declare const redoSelection: ({ state, dispatch }: {
    state: EditorState;
    dispatch: (tr: Transaction) => void;
}) => boolean;
export declare function closeHistory(tr: Transaction): Transaction;
export declare const undoDepth: (state: EditorState) => number;
export declare const redoDepth: (state: EditorState) => number;
export declare const redoSelectionDepth: (state: EditorState) => number;
export declare const undoSelectionDepth: (state: EditorState) => number;
export {};
