import { Text } from "../../doc/src";
import { Slot, SlotType } from "../../extension/src/extension";
import { EditorState } from "./state";
import { EditorSelection, SelectionRange } from "./selection";
import { Change, ChangeSet } from "./change";
export declare class Transaction {
    readonly startState: EditorState;
    readonly changes: ChangeSet;
    readonly docs: ReadonlyArray<Text>;
    readonly selection: EditorSelection;
    private readonly metadata;
    private readonly flags;
    private constructor();
    static start(state: EditorState, time?: number): Transaction;
    readonly doc: Text;
    addMeta(...metadata: Slot[]): Transaction;
    getMeta<T>(type: SlotType<T>): T | undefined;
    change(change: Change, mirror?: number): Transaction;
    replace(from: number, to: number, text: string | ReadonlyArray<string>): Transaction;
    replaceSelection(text: string | ReadonlyArray<string>): Transaction;
    reduceRanges(f: (transaction: Transaction, range: SelectionRange) => (Transaction | {
        transaction: Transaction;
        range: SelectionRange;
    })): Transaction;
    mapRanges(f: (range: SelectionRange) => SelectionRange): Transaction;
    setSelection(selection: EditorSelection): Transaction;
    readonly selectionSet: boolean;
    readonly docChanged: boolean;
    scrollIntoView(): Transaction;
    readonly scrolledIntoView: boolean;
    apply(): EditorState;
    invertedChanges(): ChangeSet<Change>;
    static time: SlotType<number>;
    static changeTabSize: SlotType<number>;
    static changeLineSeparator: SlotType<string>;
    static preserveGoalColumn: SlotType<boolean>;
    static userEvent: SlotType<string>;
    static addToHistory: SlotType<boolean>;
}
