import { ContentView } from "./contentview";
import { WidgetType } from "./decoration";
import { Rect } from "./dom";
export declare abstract class InlineView extends ContentView {
    abstract merge(from: number, to?: number, source?: InlineView | null): boolean;
    match(other: InlineView): boolean;
    readonly children: any[];
    abstract slice(from: number, to?: number): InlineView;
    getSide(): number;
}
export declare class TextView extends InlineView {
    text: string;
    tagName: string | null;
    attrs: {
        [key: string]: string;
    } | null;
    textDOM: Node | null;
    class: string | null;
    constructor(text: string, tagName: string | null, clss: string | null, attrs: {
        [key: string]: string;
    } | null);
    readonly length: number;
    createDOM(textDOM?: Node): void;
    sync(): void;
    reuseDOM(dom: Node): boolean;
    merge(from: number, to?: number, source?: InlineView | null): boolean;
    slice(from: number, to?: number): TextView;
    localPosFromDOM(node: Node, offset: number): number;
    domFromPos(pos: number): {
        node: Node;
        offset: number;
    };
    domBoundsAround(from: number, to: number, offset: number): {
        from: number;
        to: number;
        startDOM: Node;
        endDOM: Node;
    };
    coordsAt(pos: number): Rect;
    toCompositionView(): CompositionView;
}
export declare class WidgetView extends InlineView {
    length: number;
    widget: WidgetType | null;
    readonly side: number;
    readonly open: number;
    dom: HTMLElement | null;
    constructor(length: number, widget: WidgetType | null, side: number, open?: number);
    slice(from: number, to?: number): WidgetView;
    sync(): void;
    getSide(): number;
    merge(from: number, to?: number, source?: InlineView | null): boolean;
    match(other: InlineView): boolean;
    ignoreMutation(): boolean;
    ignoreEvent(event: Event): boolean;
    readonly overrideDOMText: ReadonlyArray<string>;
    domBoundsAround(): any;
    coordsAt(pos: number): Rect | null;
}
export declare class CompositionView extends InlineView {
    textDOM: Node;
    length: number;
    constructor(dom: Node, textDOM: Node, length: number);
    updateLength(newLen: number): void;
    merge(): boolean;
    slice(): InlineView;
    sync(): void;
    localPosFromDOM(node: Node, offset: number): number;
    domFromPos(pos: number): {
        node: Node;
        offset: number;
    };
    domBoundsAround(from: number, to: number, offset: number): {
        from: number;
        to: number;
        startDOM: Node;
        endDOM: Node;
    };
    coordsAt(pos: number): Rect;
}
